# main.py -- put your code here!

from machine import I2C, Pin
import pyb
import select
import ssd1306
from time import sleep, sleep_ms
from fdrawer import FontDrawer

# pybstick lite à 48MHz pour autoalimentation sur compteur Linky
pyb.freq(48000000)

# init bus i2c a 400KHz
i2c=I2C(1, freq=400000)

# reset afficheur OLED
rst=Pin("S7", Pin.OUT_PP)
rst.low()
sleep_ms(50)
rst.high()

# Initialisation afficheur
oled = ssd1306.SSD1306_I2C(width=128, height=64, i2c=i2c, addr=0x3c, external_vcc=False)
oled.init_display()

# Dessiner un rectangle blanc - rect( x, y, w, h, c )
oled.show() # doit être appelé

def display(wh, hp, hc, ph):
	oled.fill(0)
	oled.rect( 0, 0, 128, 64, 1 )
	oled.line( 92, 30, 92, 64, 1 )
	oled.line( 0, 30, 128, 30, 1 )
	fd = FontDrawer( frame_buffer=oled, font_name = 'vera_23' )
	fd.print_str(str(wh), 8, 5 )
	fd.print_str(str(ph), 96, 36 )
	fd = FontDrawer( frame_buffer=oled, font_name = 'vera_15' )
	fd.print_str("W/Hr", 80, 10 )
	fd.print_str("HP:", 8, 30 )
	fd.print_str("HC:", 8, 46 )
	fd.print_str(str(hp), 35, 32 )
	fd.print_str(str(hc), 35, 46 )
	oled.show() 

# declaration à zéro des index
wh = 'xxxxx'
hc = 'xxxxxx'
hp = 'xxxxxx'
ph = 'xx'
buffer_size = 128
loop = 0


info = pyb.UART(2, 1200, bits=7, parity=0, stop=1, timeout=0)

while 1:
	tampon=str(info.read(buffer_size))

	if tampon :
		print (tampon)
		x=tampon.find('HCHC')
		if x >=0 and x < (buffer_size-20): hc=tampon[x+5:x+11]
		x=tampon.find('HCHP') 
		if x >=0 and x < (buffer_size-20): hp=tampon[x+5:x+11]
		x=tampon.find('PAPP') 
		if x >=0 and x < (buffer_size-16) and tampon[x+10] == ' ': wh=tampon[x+5:x+10]
		x=tampon.find('PTEC') 
		if x >=0 and x < (buffer_size-16): ph=tampon[x+5:x+7]
	loop = loop + 1
	
	if loop >= 3:
		display(wh, hp, hc, ph)
		loop = 0
